//+------------------------------------------------------------------+
//|                                                  Shaolin Quantum |
//|                                      Copyright 2015, Alex Lewis  |
//+------------------------------------------------------------------+ 
#property strict
const string ver = "1.3.2 -> ( Two Time Slot & Day Option & Individual Lot 1 to Lot 40 Size )";
input int magic_num=2015; //Magic Number
input string time_open_str1="02:00"; // Trading Window Start Time (GMT)
input string time_close_str1="03:00"; // Trading Window End Time (GMT)
input int max_trades1=0;//Max Trades Per Trading Window (0 = unlimited)
input int max_cycles1=0;//Max Cycles Per Trading Window (0 = unlimited)
input string time_open_str2="21:15"; // Trading Window Start Time (GMT)
input string time_close_str2="23:45"; // Trading Window End Time (GMT)
input int max_trades2=0;//Max Trades Per Trading Window (0 = unlimited)
input int max_cycles2=0;//Max Cycles Per Trading Window (0 = unlimited)
input bool mon=true;//Trade on Monday
input bool tue=true;//Trade on Tuesday
input bool wed=true;//Trade on Wednesday
input bool thurs=true;//Trade on Thursday
input bool fri=false;//Trade on Friday
input int qde=500;//Quantum eintDepth3 for Entry
input int qdc=500;//Quantum eintDepth3 for Close
input int slip=10;//Order Slippage
input string awa="------------------------------------------------------";
input string axa="-------  CHOOSE LOT WISELY AND MARKET ENTRY    -------";
input string aya="------------------------------------------------------";
input double lot1=0.01; //Lot Trade 1
input double lot2=0.01; //Lot Trade 2
input double lot3=0.01; //Lot Trade 3
input double lot4=0.01; //Lot Trade 4
input double lot5=0.01; //Lot Trade 5
input double lot6=0.01; //Lot Trade 6
input double lot7=0.01; //Lot Trade 7
input double lot8=0.01; //Lot Trade 8
input double lot9=0.01; //Lot Trade 9
input double lot10=0.01; //Lot Trade 10
input double lot11=0.01; //Lot Trade 11
input double lot12=0.01; //Lot Trade 12
input double lot13=0.01; //Lot Trade 13
input double lot14=0.01; //Lot Trade 14
input double lot15=0.01; //Lot Trade 15
input double lot16=0.01; //Lot Trade 16
input double lot17=0.01; //Lot Trade 17
input double lot18=0.01; //Lot Trade 18
input double lot19=0.01; //Lot Trade 19
input double lot20=0.01; //Lot Trade 20
input double lot21=0.01; //Lot Trade 21
input double lot22=0.01; //Lot Trade 22
input double lot23=0.01; //Lot Trade 23
input double lot24=0.01; //Lot Trade 24
input double lot25=0.01; //Lot Trade 25
input double lot26=0.01; //Lot Trade 26
input double lot27=0.01; //Lot Trade 27
input double lot28=0.01; //Lot Trade 28
input double lot29=0.01; //Lot Trade 29
input double lot30=0.01; //Lot Trade 30
input double lot31=0.01; //Lot Trade 31
input double lot32=0.01; //Lot Trade 32
input double lot33=0.01; //Lot Trade 33
input double lot34=0.01; //Lot Trade 34
input double lot35=0.01; //Lot Trade 35
input double lot36=0.01; //Lot Trade 36
input double lot37=0.01; //Lot Trade 37
input double lot38=0.01; //Lot Trade 38
input double lot39=0.01; //Lot Trade 39
input double lot40=0.01; //Lot Trade 40 & >
input double sl_pct=0;//% Equity Stop Loss For All Trades (positive number Eg 2.5)
input double tp_pct=0;//% Equity Take Profit For All Trades (positive number Eg 2.5)
input double sl_dollar=0;//$ Amount Stop Loss For All Trades (positive number Eg 100.00)
input double tp_dollar=0;//$ Amount Take Profit For All Trades (positive number Eg 100.00)
input int sl_points=0;// Stop Loss Points Per Trade (Eg 50 = 5 pips)
input int tp_points=0;// Take Profit Points Per Trade (Eg 50 = 5 pips)
input int min_price_diff=20;//Minimum Points Between Trades (Eg 50 = 5 pips)

int cycles = 0;
int trades = 0;
int trade_side = -1;
datetime day_curr;
datetime day_prev; 
int bars = Bars;
double lastTradePrice = 0;

int init()
{
   return 0;
}

int deinit()
{
   return 0;
}

int start()
{
   datetime time_broker = TimeCurrent();
   datetime time_curr = TimeGMT();
   datetime time_open1 = StrToTime(time_open_str1);
   datetime time_close1 = StrToTime(time_close_str1);
   datetime time_open2 = StrToTime(time_open_str2);
   datetime time_close2 = StrToTime(time_close_str2);
   MqlDateTime dtct;
   MqlDateTime dto1, dtc1;
   MqlDateTime dto2, dtc2;
   TimeToStruct(time_curr, dtct);
   TimeToStruct(time_open1, dto1);
   TimeToStruct(time_close1, dtc1);
   TimeToStruct(time_open2, dto2);
   TimeToStruct(time_close2, dtc2);
   dto1.year = dtc1.year = dtct.year;
   dto1.mon = dtc1.mon = dtct.mon;
   dto1.day = dtc1.day = dtct.day;
   dto2.year = dtc2.year = dtct.year;
   dto2.mon = dtc2.mon = dtct.mon;
   dto2.day = dtc2.day = dtct.day;
   time_open1 = StructToTime(dto1);
   time_close1 = StructToTime(dtc1);
   time_open2 = StructToTime(dto2);
   time_close2 = StructToTime(dtc2);
    
   
   if (time_open1 > time_close1) {
      //assume next day
      time_close1 += 86400;
   }
   
   if (time_open2 > time_close2) {
      //assume next day
      time_close2 += 86400;
   }
   
   Comment("\n","     Shaolin Quantum v",ver,"\n","\n        Broker_time: ",time_broker,"\n","\n        GMT_time: ",time_curr,"\n","\n        Time Open (GMT): ",time_open1,"\n","\n        Time Close (GMT): ",time_close1,"\n","\n        Time Open (GMT): ",time_open2,"\n","\n        Time Close (GMT): ",time_close2);
   
   bool barNext = false;
   
   day_curr=iTime(Symbol(),PERIOD_D1,0);
   if(day_curr > day_prev)
   {
      cycles=0;
      day_prev=iTime(Symbol(),PERIOD_D1,0);
   }

   checkCloseTrades();
   
   if (Bars > bars) {
      bars = Bars;
      barNext = true;
   }

   bool cantrade=true;
   
   if (((cycles < max_cycles1 || max_cycles1 == 0) && (trades < max_trades1 || max_trades1 == 0) && time_curr >= time_open1 && time_curr < time_close1) || ((cycles < max_cycles2 || max_cycles2 == 0) && (trades < max_trades2 || max_trades2 == 0) && time_curr >= time_open2 && time_curr < time_close2) && barNext)
   {
      int nextTicket = -1;
      bool trade = false;
      double price = 0;
      double tp = 0, sl = 0;
      if(mon==false && DayOfWeek()==1)
         cantrade=false;
      if(tue==false && DayOfWeek()==2)
         cantrade=false;
      if(wed==false && DayOfWeek()==3)
         cantrade=false;
      if(thurs==false && DayOfWeek()==4)
         cantrade=false;
      if(fri==false && DayOfWeek()==5)
         cantrade=false;
      //buy
      if(cantrade==true)
      {
      if (iCustom(Symbol(),0,"Quantum",qde,0,1) > 0 && (trade_side == -1 || trade_side == OP_BUY)) 
      {
         trade_side = OP_BUY;
         trade = true;
         price = Ask;
         if (tp_points)
            tp = price + (tp_points*Point);
         if (sl_points)
            sl = price - (sl_points*Point);
      }
      else
      //sell
      if (iCustom(Symbol(),0,"Quantum",qde,1,1) > 0 && (trade_side == -1 || trade_side == OP_SELL)) 
      {
         trade_side = OP_SELL;
         trade = true;
         price = Bid;
         if (tp_points)
            tp = price - (tp_points*Point);
         if (sl_points)
            sl = price + (sl_points*Point);
      }
      }
      //trade
      if (trade) 
      {
         //check minimum dist
         if (min_price_diff != 0) {
            double diff = MathAbs(price - lastTradePrice);
            if (diff < (min_price_diff*Point)) {
               Print("Minimum Price Diff Not Met: ",diff);
               return 0;
            }
         }
         
         nextTicket = OrderSend(Symbol(), trade_side, getLots(), price, slip, sl, tp, "SHAOLIN", magic_num, 0, 0);
         
         if(nextTicket <= -1) 
         {
            Print("OrderSend Error: ",GetLastError());
         } 
         else 
         {
            lastTradePrice = price;
            trades++;
         }
      }
   }
   
   return 0;
}

double getLots()
{
   double retlot = 0.01;

   if(trades>=0 && trades<1)
	   retlot=lot1;
   if(trades>=1 && trades<2)
		retlot=lot2;
	if(trades>=2 && trades<3)
		retlot=lot3;
   if(trades>=3 && trades<4)
		retlot=lot4;
	if(trades>=4 && trades<5)
		retlot=lot5;
	if(trades>=5 && trades<6)
		retlot=lot6;
	if(trades>=6 && trades<7)
		retlot=lot7;
	if(trades>=7 && trades<8)
		retlot=lot8;
	if(trades>=8 && trades<9)
		retlot=lot9;
	if(trades>=9 && trades<10)
		retlot=lot10;
	if(trades>=10 && trades<11)
		retlot=lot11;
	if(trades>=11 && trades<12)
		retlot=lot12;
	if(trades>=12 && trades<13)
		retlot=lot13;
	if(trades>=13 && trades<14)
		retlot=lot14;
	if(trades>=14 && trades<15)
		retlot=lot15;
	if(trades>=15 && trades<16)
		retlot=lot16;
	if(trades>=16 && trades<17)
		retlot=lot17;
	if(trades>=17 && trades<18)
		retlot=lot18;
	if(trades>=18 && trades<19)
		retlot=lot19;
	if(trades>=19 && trades<20)
		retlot=lot20;
	if(trades>=20 && trades<21)
		retlot=lot21;
	if(trades>=21 && trades<22)
		retlot=lot22;
	if(trades>=22 && trades<23)
		retlot=lot23;
	if(trades>=23 && trades<24)
		retlot=lot24;
   if(trades>=24 && trades<25)
		retlot=lot25;
	if(trades>=25 && trades<26)
	   retlot=lot26;
	if(trades>=26 && trades<27)
		retlot=lot27;
	if(trades>=27 && trades<28)
		retlot=lot28;
	if(trades>=28 && trades<29)
		retlot=lot29;
	if(trades>=29 && trades<30)
		retlot=lot30;
	if(trades>=30 && trades<31)
		retlot=lot31;
	if(trades>=31 && trades<32)
		retlot=lot32;
	if(trades>=32 && trades<33)
		retlot=lot33;
	if(trades>=33 && trades<34)
		retlot=lot34;
	if(trades>=34 && trades<35)
		retlot=lot35;
	if(trades>=35 && trades<36)
	   retlot=lot36;
	if(trades>=36 && trades<37)
	   retlot=lot37;
	if(trades>=37 && trades<38)
	   retlot=lot38;
	if(trades>=38 && trades<39)
	   retlot=lot39;
	if(trades>=39 && trades<40)
	   retlot=lot40;

   return retlot;
}

void checkCloseTrades()
{
   bool close = false;

   if (trades > 0)
   {
      if((sl_pct > 0 && AccountEquity() <= (AccountBalance() - (AccountBalance() * (sl_pct/100)))) ||
         (sl_dollar > 0 && AccountEquity() <= (AccountBalance() - sl_dollar)))
      {
         close = true;
         Print("Stoploss Triggered");
      }
      else if((tp_pct > 0 && AccountEquity() >= (AccountBalance() + (AccountBalance() * (tp_pct/100)))) ||
         (tp_dollar > 0 && AccountEquity() >= (AccountBalance() + tp_dollar)))
      {
         close = true;
         Print("Take Profit Triggered");
      }
      else
      {
         close = (iCustom(Symbol(),0,"Quantum",qdc,1,1) > 0 && trade_side == OP_BUY) || (iCustom(Symbol(),0,"Quantum",qdc,0,1) > 0 && trade_side == OP_SELL); 
      }
      
      if (close)
      {
         while (trades > 0)
         {          
            int tradeList[][2];  
            int size = 0;
            
            for(int h = OrdersTotal()-1; h >= 0; h--)
            {
               if(!OrderSelect(h,SELECT_BY_POS,MODE_TRADES))
                  continue;
               if(OrderSymbol() == Symbol() && OrderMagicNumber() == magic_num)
               {
                  size++;
                  ArrayResize(tradeList, size);
                  tradeList[size-1][0]=OrderOpenTime();
                  tradeList[size-1][1]=OrderTicket();
               }
            }
            
            if (size > 0)
            {
               ArraySort(tradeList);
               
               for(int i=0; i < size; i++)
               {
                  if (!OrderSelect(tradeList[i][1],SELECT_BY_TICKET))
                     continue;
                  if(OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),0,0))
                  {
                     trades--;
                  }
                  else
                  {
                     Print("OrderClose Error: ",GetLastError());
                  }
               }
            }
            else
            {
               trades = 0;
            }
         }
         cycles++;
         trade_side = -1;
         lastTradePrice = 0;
      }
   }
}